con         
  MAXP  = 10_000

  PSIZE = MAXP/32+1
  
obj
  driver: "cogOScoreRAM"
  tibug: "FullDuplexSerial_NP2"

var
  long PrimBits[ PSIZE ]
  
pub main | argc, argv, tmp, i, j, countp
  driver.initRAMDesc
  i := driver.findRAMDrv( 0, driver.Hash( string("FDSerial"), $0110 ) )
  ' no driver found, so it's better to stay in an endless loop
  if i==-1
    repeat
    
  tibug.start(0,0,0,0, driver.getRAMParAddress( i ) )

  tibug.tx(0)   
  tibug.str( string( "Prime Number Generator",$0d ) )

  ' printBits

  countp:=0
  repeat i from 2 to MAXP
    tmp:=getBit( i )
    if tmp == 0
      printZahl( i )
      countp++
      ' tibug.tx( $0d )
      j:= i*2
      repeat while j =< MAXP
        setBit( j )
        j+=i

  tibug.tx( $0d )
  tibug.str( string( "In the range from 2 to " ) )
  tibug.dec( MAXP )
  tibug.str( string( " there are " ) )
  tibug.dec( countp )
  tibug.str( string( " prime-numbers!", $0d ) )
  
  long[ @argc ]:=0

  repeat
        
pub printZahl (pZ) | hoch10, pn, x
  hoch10:=10_000_000

  pn := false
  repeat until pZ ==  0
    x := pZ/hoch10
    if x or pn
      tibug.dec( x )
      pn := true
    else
      tibug.tx(" ")

    pZ -= x * hoch10
    hoch10 /= 10

pub printBits | i
  repeat i from 0 to constant(PSIZE*32-1)
    tibug.dec( getBit( i ) )
    tibug.tx( " " )
    waitcnt( clkfreq/29 + cnt )

pub getBit( _BitNr ) | LongNr
  LongNr := _BitNr / 32
  _BitNr := _BitNr // 32

  return ((PrimBits[ LongNr ] & |< _BitNr) <> 0) & 1

pub setBit ( _BitNr ) | LongNr
  LongNr := _BitNr / 32
  _BitNr := _BitNr // 32
  
  PrimBits[ LongNr ] |= |< _BitNr    